#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

/* Table of constant values */

/*static int c__1 = 1;
static int c__2 = 2; */

 int main(void)
{
    /* System generated locals */
    int i__1, i__2, i__3;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, l, m;
    static double p[65], q, s[77], u[22] /* was [2][11] */, x;
    static int k0;
    static double x1, au[28] /* was [2][14] */, du[22] /* was [2][11] */, xk;
    static int nx;
    static double xp, yp[2], yt[2], yx[2];
    static int kp1, kp2, kp3;
    static double xj0[11], ajk[24] /* was [2][12] */, adu[26] /* was [2][13] */,
            alp[11], zfi[28] /* was [2][14] */, dyp[2],
	    dyt[2], dyx[2], hd4i[12], rabc[11];
    extern int de78d_c( );
    static double cmar[121] /* was [11][11] */, ajkp[24] /* was [2][12] */,
                  alpn[11], dely[2];
    static int imax;
    static double rabc1[11], rabc2[13], rabc3[13], deldy[2];
    static int iniapr, jstarn, jstart;

/*       take into consideraitoin: all arraies depending on K */
/*              must be described for maximal value K */

    m = 2;
    q = .5;
    x = -.44444444444444442;
    x1 = x * 2. - 1.;
    yx[0] = cos(q * x1) + 3.;
    yx[1] = sin(q * x1) + 2.;
    dyx[0] = q * -2. * sin(q * x1);
    dyx[1] = q * 2. * cos(q * x1);
    h__ = .1111111111111111;
    xk = x + h__;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    imax = 12;
    jstarn = 0;
    jstart = jstarn;
    iniapr = 1;
    k0 = 6;

    de78d_c((U_fp)f_c, &m, &k0, &iniapr, &imax, &jstart, yx, dyx, &x, xj0, au,
	    adu, ajk, &h__, hd4i, rabc, rabc1, rabc2, rabc3, alp, alpn, cmar,
	    p, s, &xp, yp, dyp, ajkp, u, du, zfi);

    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];
    deldy[0] = dyt[0] - dyx[0];
    deldy[1] = dyt[1] - dyx[1];

    printf("\n ------------------------------------------------------------\n");
    printf("\n RESULTS AFTER THE FIRST CALL SUBROUTINE DE78D\n");

    printf("\n xp= %21.14e  x= %21.14e \n\n",xp, x);

    printf("\n h=%21.14e k0 =%3i iniapr= %1i imax=%3i jstart(initial)=%3i\n\n", h__, k0,iniapr,imax,jstarn);

    printf("\n yx= %21.14e %21.14e\n", yx[0], yx[1]);
    printf("\n yt= %21.14e %21.14e\n",yt[0], yt[1]);
    printf("\n dely= %23.14e %21.14e\n\n", dely[0], dely[1]);

    printf("\n dyx= %21.14e %21.14e\n",dyx[0], dyx[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0], dyt[1]);
    printf("\n deldy= %23.14e %21.14e \n", deldy[0], deldy[1]);
    printf("\n ------------------------------------------------------------\n");

    nx = 1;
    goto L15;
/* __________________________________ */

L1:
    h__ = .33333333333333331;
    xk = x + h__;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    imax = 14;

/*  take into consideraitoin: parameter JSTART must be equal to zero */

    jstart = jstarn;
    k0 = 8;

    de78d_c((U_fp)f_c, &m, &k0, &iniapr, &imax, &jstart, yx, dyx, &x, xj0, au,
	    adu, ajk, &h__, hd4i, rabc, rabc1, rabc2, rabc3, alp, alpn, cmar,
	    p, s, &xp, yp, dyp, ajkp, u, du, zfi);

    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];
    deldy[0] = dyt[0] - dyx[0];
    deldy[1] = dyt[1] - dyx[1];

    printf("\n ------------------------------------------------------------\n");
    printf("\n RESULTS AFTER THE SECOND CALL SUBROUTINE DE78D\n");

    printf("\n xp= %21.14e  x= %21.14e \n\n",xp, x);

    printf("\n h=%21.14e k0 =%3i iniapr= %1i imax=%3i jstart(initial)=%3i\n\n", h__, k0,iniapr,imax,jstarn);

    printf("\n yx= %21.14e %21.14e\n", yx[0], yx[1]);
    printf("\n yt= %21.14e %21.14e\n",yt[0], yt[1]);
    printf("\n dely= %23.14e %21.14e\n\n", dely[0], dely[1]);

    printf("\n dyx= %21.14e %21.14e\n",dyx[0], dyx[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0], dyt[1]);
    printf("\n deldy= %23.14e %21.14e \n", deldy[0], deldy[1]);
    printf("\n ------------------------------------------------------------\n");

    nx = 2;
    goto L15;
/* __________________________________________ */

L2:
    h__ = 1.;
    xk = x + h__;
    x1 = xk * 2. - 1.;
    yt[0] = cos(q * x1) + 3.;
    yt[1] = sin(q * x1) + 2.;
    dyt[0] = q * -2. * sin(q * x1);
    dyt[1] = q * 2. * cos(q * x1);
    imax = 17;

/*  take into consideraitoin: parameter JSTART must be equal to zero */

    jstart = jstarn;
    k0 = 11;

    de78d_c((U_fp)f_c, &m, &k0, &iniapr, &imax, &jstart, yx, dyx, &x, xj0, au,
	    adu, ajk, &h__, hd4i, rabc, rabc1, rabc2, rabc3, alp, alpn, cmar,
	    p, s, &xp, yp, dyp, ajkp, u, du, zfi);

    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];
    deldy[0] = dyt[0] - dyx[0];
    deldy[1] = dyt[1] - dyx[1];

    printf("\n ------------------------------------------------------------\n");
    printf("\n RESULTS AFTER THE THIRD CALL SUBROUTINE DE78D\n");

    printf("\n xp= %21.14e  x= %21.14e \n\n",xp, x);

    printf("\n h=%21.14e k0 =%3i iniapr= %1i imax=%3i jstart(initial)=%3i\n\n", h__, k0,iniapr,imax,jstarn);

    printf("\n yx= %21.14e %21.14e\n", yx[0], yx[1]);
    printf("\n yt= %21.14e %21.14e\n",yt[0], yt[1]);
    printf("\n dely= %23.14e %21.14e\n\n", dely[0], dely[1]);

    printf("\n dyx= %21.14e %21.14e\n",dyx[0], dyx[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0], dyt[1]);
    printf("\n deldy= %23.14e %21.14e \n", deldy[0], deldy[1]);
    printf("\n ------------------------------------------------------------\n");
/* ____________________________________________ */

    nx = 3;
L15:
    kp3 = k0 + 3;
    kp2 = k0 + 2;
    kp1 = k0 + 1;

    printf("\n\n  COEFFICIENTS AU, ADU AND AJK ON %3i SEGMENT \n", nx);

    i__1 = m;
    for (l = 1; l <= i__1; ++l) {

    printf("\n                  Chebyshev coefficients  for %i component \n", l);
    printf("\n              for Y                   for  Y'                for Y'' \n");

	i__2 = kp1;
	for (j = 1; j <= i__2; ++j) {
	    i__3 = j - 1;

         printf("\n %3i %23.14e %23.14e %23.14e", i__3, au[l + (j << 1) - 3], adu[l + (j << 1) - 3], ajk[l + (j << 1) - 3]);
	}
         printf("\n %3i %23.14e %23.14e", kp1, au[l + (kp2 << 1) - 3], adu[l + (kp2 << 1) - 3]);
         printf("\n %3i %23.14e \n", kp2, au[l + (kp3 << 1) - 3]);
    }
    switch (nx) {
	case 1:  goto L1;
	case 2:  goto L2;
	case 3:  goto L7;
    }
L7:
    return 0;
} /* main */


 int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double);

    /* Local variables */
    static real q;

    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    q = .5f;
/* Computing 2nd power */
    d__1 = (1. - exp(3. - y[1] + dy[2] * .5 / q)) / (*x + 1.);
    z__[1] = q * -2. * dy[2] - d__1 * d__1;
/* Computing 2nd power */
    d__1 = dy[2] - q * 2. * (y[1] - 3.);
    z__[2] = q * 2. * dy[1] - d__1 * d__1;
    return 0;
} /* f_c */
